<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" doctype-system="bibtexml.dtd"/>

<xsl:template match="bibxml">
<bibliography>
<xsl:apply-templates/>
</bibliography>
</xsl:template>


<xsl:template match="String">
<xsl:element name="macro">
<xsl:attribute name="alias">
<xsl:value-of select="alias"/>
</xsl:attribute>
<xsl:value-of select="macrotext"/>
</xsl:element>
</xsl:template>

<xsl:template match="Preamble">
<xsl:element name="preamble">
<xsl:value-of select="."/>
</xsl:element>
</xsl:template>


  
<xsl:template match="TechReport">
<bibitem type="techreport">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="MastersThesis">
<bibitem type="mastersthesis">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Misc">
<bibitem type="misc">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>


<xsl:template match="InProceedings">
<bibitem type="inproceedings">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Article">
<bibitem type="article">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Book">
<bibitem type="book">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Booklet">
<bibitem type="booklet">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="InBook">
<bibitem type="inbook">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Conference">
<bibitem type="conference">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="InCollection">
<bibitem type="incollection">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="PhdThesis">
<bibitem type="phdthesis">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Unpublished">
<bibitem type="unpublished">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Proceedings">
<bibitem type="proceedings">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="Manual">
<bibitem type="manual">
<xsl:attribute name="label">
<xsl:value-of select="label"/>
</xsl:attribute>
<xsl:apply-templates/>
</bibitem>
</xsl:template>

<xsl:template match="label"></xsl:template>

<xsl:template match="author">
<xsl:if test="ref"><author><abbrev><xsl:attribute name="alias"><xsl:copy-of
select="ref"/></xsl:attribute></abbrev></author></xsl:if>
<xsl:if test="not(ref)"><xsl:call-template name="and">
<xsl:with-param name="string1" select="normalize-space(.)"/>
</xsl:call-template></xsl:if>
</xsl:template>

<xsl:template match="school">
<school><xsl:apply-templates/></school> 
</xsl:template>

<xsl:template match="institution">
<institution><xsl:apply-templates/></institution> 
</xsl:template>

<xsl:template match="organization">
<organization><xsl:apply-templates/></organization> 
</xsl:template>

<xsl:template match="title">
<title><xsl:apply-templates/></title> 
</xsl:template>

<xsl:template match="booktitle">
<booktitle><xsl:apply-templates/></booktitle>
</xsl:template>

<xsl:template match="publisher">
<publisher><xsl:apply-templates/></publisher>
</xsl:template>

<xsl:template match="howpublished">
<howpublished><xsl:apply-templates/></howpublished>
</xsl:template>

<xsl:template match="editor">
<editor><xsl:apply-templates/></editor>
</xsl:template>

<xsl:template match="edition">
<edition><xsl:apply-templates/></edition>
</xsl:template>

<xsl:template match="journal">
<journal><xsl:apply-templates/></journal>
</xsl:template>

<xsl:template match="number">
<number><xsl:apply-templates/></number>
</xsl:template>

<xsl:template match="series">
<series><xsl:apply-templates/></series>
</xsl:template>

<xsl:template match="key">
<key><xsl:apply-templates/></key> 
</xsl:template>

<xsl:template match="type">
<type><xsl:apply-templates/></type> 
</xsl:template>

<xsl:template match="volume">
<volume><xsl:apply-templates/></volume> 
</xsl:template>

<xsl:template match="chapter">
<chapter><xsl:apply-templates/></chapter> 
</xsl:template>
<xsl:template match="pages">
<pages><xsl:apply-templates/></pages>
</xsl:template>

<xsl:template match="month">
<month><xsl:apply-templates/></month>
</xsl:template>

<xsl:template match="year">
<year><xsl:apply-templates/></year>
</xsl:template>

<xsl:template match="annote">
<annote><xsl:apply-templates/></annote> 
</xsl:template>

<xsl:template match="note">
<note><xsl:apply-templates/></note> 
</xsl:template>

<xsl:template match="crossref">
<crossref><xsl:apply-templates/></crossref>
</xsl:template>

<xsl:template match="address">
<address><xsl:apply-templates/></address>
</xsl:template>

<xsl:template match="annotate">
<annotate><xsl:apply-templates/></annotate>
</xsl:template>

<xsl:template match="abstract">
<abstract><xsl:apply-templates/></abstract>
</xsl:template>

<xsl:template match="contents">
<contents><xsl:apply-templates/></contents>
</xsl:template>

<xsl:template match="ISBN">
<ISBN><xsl:apply-templates/></ISBN>
</xsl:template>

<xsl:template match="ISSN">
<ISSN><xsl:apply-templates/></ISSN> 
</xsl:template>

<xsl:template match="language">
<language><xsl:apply-templates/></language>
</xsl:template>

<xsl:template match="location">
<location><xsl:apply-templates/></location>
</xsl:template>

<xsl:template match="URL">
<URL><xsl:apply-templates/></URL> 
</xsl:template>

<xsl:template match="keywords">
<keywords><xsl:apply-templates/></keywords>
</xsl:template>

<xsl:template match="copyright">
<copyright><xsl:apply-templates/></copyright>
</xsl:template>

<xsl:template match="ref"><xsl:element name="abbrev">
<xsl:attribute name="alias"><xsl:apply-templates/></xsl:attribute>
</xsl:element>
</xsl:template>

<xsl:template name="and">
<xsl:choose>
<xsl:when test="contains($string1,' and ')">
<author>
<xsl:call-template name="spaces">
<xsl:with-param name="ciao"><xsl:value-of select="substring-before($string1,' and')"/></xsl:with-param>
<xsl:with-param name="num">one</xsl:with-param></xsl:call-template></author><xsl:call-template name="and"><xsl:with-param name="string1" select="substring-after($string1,' and ')"/></xsl:call-template></xsl:when>
<xsl:otherwise>
<author>
<xsl:call-template name="spaces">
<xsl:with-param name="ciao"><xsl:value-of select="$string1"/></xsl:with-param>
<xsl:with-param name="num">one</xsl:with-param>
</xsl:call-template>
</author>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="spaces">
<xsl:choose>
	<xsl:when test="contains($ciao,' ')">
		<xsl:if test="contains($num,'one')">
			<xsl:choose>
				<xsl:when test="starts-with($ciao,'{')">
				<xsl:param name="part1" select="substring-before($ciao,'}')"/>
				<lastname><xsl:value-of select="substring($part1,2)"/></lastname>
				</xsl:when>
				<xsl:otherwise>
				<firstname><xsl:value-of select="substring-before($ciao,' ')"/></firstname>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:if test="contains($num,'two')">
			<xsl:choose>
				<xsl:when test="starts-with($ciao,'{')">
				<xsl:param name="part1" select="substring-before($ciao,'}')"/>
					<xsl:if test="not(contains(substring($part1,2),','))">
					<lastname><xsl:value-of select="substring($part1,2)"/></lastname></xsl:if>
					<xsl:if test="contains(substring($part1,2),',')">
					<lastname><xsl:value-of select="substring-before(substring($part1,2),',')"/></lastname>
					<suffix><xsl:value-of select="substring-after(substring($part1,2),',')"/></suffix></xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="starts-with(substring-before($ciao,' '),'v') or starts-with(substring-before($ciao,' '),'d')">
						<lastname><xsl:value-of
select="$ciao"/></lastname></xsl:when>
						<xsl:otherwise>
						<middlename><xsl:value-of select="substring-before($ciao,' ')"/></middlename>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:if test="not(starts-with($ciao,'{'))">
		<xsl:choose>
			<xsl:when test="starts-with(substring-before($ciao,' '),'v') or starts-with(substring-before($ciao,' '),'d')"></xsl:when>
			<xsl:otherwise>
			<xsl:call-template name="spaces">
			<xsl:with-param name="ciao" select="substring-after($ciao,' ')"/>
			<xsl:with-param name="num">two</xsl:with-param>
			</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		</xsl:if>
	</xsl:when>
	<xsl:otherwise>
	<lastname><xsl:value-of select="$ciao"/></lastname>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="tex">
<xsl:element name="tex">
<xsl:attribute name="code">
<xsl:value-of select="@code"/>
</xsl:attribute>
<xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="text()">
<xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="*">
<xsl:element name="notstandard">
<xsl:attribute name="name">
<xsl:value-of select="local-name(.)"/>
</xsl:attribute>
<xsl:apply-templates/>
</xsl:element>
</xsl:template>


</xsl:stylesheet>
